package cnv.hf.widgets;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.animation.AlphaAnimation;
import android.view.animation.Interpolator;
import android.view.animation.RotateAnimation;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;
import android.view.animation.Animation.AnimationListener;
import cnv.hf.widgets.HFDrawableWidget.HFDrawableEffect;
import cnv.hf.widgets.HFModesManager.HFOnLaunchDrawableInterface;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFDrawableStorage;

public class HFBaseWidget extends HFBaseObject{

	private   int                       binder;                 //󶨱־
	private long 						WidgetParent;			//ؼID
	private HFDrawableWidget			defaultDrawable;		//ɫͼƬ
	private short						order;					/*ؼ*/			
	private short						leftOrder;				/**/		
	private short						rightOrder;				/*ҷ*/		
	private short						upOrder;				/*Ϸ*/		
	private short						downOrder;				/*·*/			
	private short               		widgetAlpha;			//͸־(0-100)
	private HFOnWidgetClickInterface	mOnClickListener;		//ص
	private HFOnWidgetLongClickInterface mOnLongClickListener;  //¼ص
	private HFOnWidgetDrawInterface		mOnDrawListener;		//ƻص
	// added by LiangYJ 20150702
	private HFOnWidgetDrawAfterInterface		mOnDrawAfterListener;		//֮ص
	//end
	private static long backupOnClickTime = 0;                         //һε¼
	private long onClickTimeInterval = 0;                     //ʱ
	private boolean mVisible = true;                          //Ƿ
	private int     mModeId = 0;                              //ؼģʽID
	
	private HFAnalyticsClickStorage mClickStorage;
	
	private boolean mQuickClickable = false;                  //ǷԿٵ
	
	/*======================================================
	: Ĺ캯
	: Context 		[in] Context
	      widgetData 	[in] 	
	ֵ: 
	======================================================*/
	public HFBaseWidget(Context context, Object widgetData) {
		super(context, widgetData);
		//ʼؼ
		initBaseMembers(widgetData);
	}
	//androidɫıʾwindowsͬ
	//android϶ɫıʾΪ: argb  ɫʾΪFFFF0000
	//windowsϵıʾΪ0000FF
	protected int convert2ARGB(int color) {
	
		int red = (color & 0x000000FF);
		int green = ((color>>8) & 0x000000FF);
		int blue = ((color>>16) & 0x000000FF);
		
		return Color.rgb(red, green, blue);
	}
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDrawable(HFDrawableStorage ds) {
		
		HFDrawableWidget drawable = null;
		if(ds != null) {
			drawable = new HFDrawableWidget();
			if((ds.getEffect()& HFDrawableEffect.eDrawableEffect_Bitmap) ==  HFDrawableEffect.eDrawableEffect_Bitmap) {
				Drawable bitmap = getDrawable(ds);
				if(bitmap != null) {
					bitmap.setBounds(0, 0, ds.getWidth(), ds.getHeight());
					drawable.setBitmap(bitmap);
				}
			}
			drawable.setColor(ds.getColor());
			drawable.setColorFilter(ds.getColorFilter());
			drawable.setEffect(ds.getEffect());
			drawable.setRender(ds.getRender());
			drawable.setHeight(ds.getHeight());
			drawable.setWidth(ds.getWidth());
		}
		return drawable;
	}
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds, boolean isChildren,HFWidgetBound mDrawBound) {
		return convertDynamicDrawable(ds,isChildren,mDrawBound,-1,0);
	}	
	//added by LiangYJ 20150617
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	     defaultResId ĬͼƬ·
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds, boolean isChildren,HFWidgetBound mDrawBound,int defaultResId,int radius) {
		
		HFDrawableWidget drawable = null;
		if(ds != null) {
			drawable = new HFDrawableWidget();
			if((ds.getEffect()& HFDrawableEffect.eDrawableEffect_Bitmap) ==  HFDrawableEffect.eDrawableEffect_Bitmap) {
				int bitmapId = ds.getBitmap();
				if(bitmapId > 0) {
					HFDynamicDrawable bitmap = new HFDynamicDrawable(this, 
															bitmapId, defaultResId,
															isChildren,isChildren == true?mDrawBound:null);
					if(bitmap != null) {
						bitmap.setBounds(0, 0, ds.getWidth(), ds.getHeight());
						drawable.setBitmap(bitmap);
						
						//ͼƬɫЧõɫֵ
						if((ds.getEffect()& HFDrawableEffect.eDrawableEffect_Both) ==  HFDrawableEffect.eDrawableEffect_Both){
							bitmap.setDrawColor(ds.getColor());
							bitmap.setDrawRadius(radius);
						}
					}
				}
			}
			drawable.setColor(ds.getColor());
			drawable.setColorFilter(ds.getColorFilter());
			drawable.setEffect(ds.getEffect());
			drawable.setRender(ds.getRender());
			drawable.setHeight(ds.getHeight());
			drawable.setWidth(ds.getWidth());
		}
		return drawable;
	}	
	//end
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	     defaultResId ĬͼƬ·
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds, boolean isChildren,HFWidgetBound mDrawBound,int[] defaultResId,int radius) {
		
		HFDrawableWidget drawable = null;
		if(ds != null) {
			drawable = new HFDrawableWidget();
			if((ds.getEffect()& HFDrawableEffect.eDrawableEffect_Bitmap) ==  HFDrawableEffect.eDrawableEffect_Bitmap) {
				int bitmapId = ds.getBitmap();
				if(bitmapId > 0) {
					HFDynamicDrawable bitmap = new HFDynamicDrawable(this, 
															bitmapId, defaultResId,
															isChildren,isChildren == true?mDrawBound:null);
					if(bitmap != null) {
						bitmap.setBounds(0, 0, ds.getWidth(), ds.getHeight());
						drawable.setBitmap(bitmap);
						
						//ͼƬɫЧõɫֵ
						if((ds.getEffect()& HFDrawableEffect.eDrawableEffect_Both) ==  HFDrawableEffect.eDrawableEffect_Both){
							bitmap.setDrawColor(ds.getColor());
							bitmap.setDrawRadius(radius);
						}
					}
				}
			}
			drawable.setColor(ds.getColor());
			drawable.setColorFilter(ds.getColorFilter());
			drawable.setEffect(ds.getEffect());
			drawable.setRender(ds.getRender());
			drawable.setHeight(ds.getHeight());
			drawable.setWidth(ds.getWidth());
		}
		return drawable;
	}	
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds) {
		return convertDynamicDrawable(ds, false,null);
	}
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	     defaultResId ĬͼƬid
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds,int defaultResId) {
		return convertDynamicDrawable(ds, false,null,defaultResId,0);
	}
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	     defaultResId ĬͼƬid
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds,int[] defaultResId) {
		return convertDynamicDrawable(ds, false,null,defaultResId,0);
	}
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	     defaultResId ĬͼƬid
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds,int defaultResId,int radius) {
		return convertDynamicDrawable(ds, false,null,defaultResId,radius);
	}
	/*======================================================
	: 洢ṹdrawableתΪڴṹdrawable
	: ds [in] 洢ṹdrawable
	     defaultResId ĬͼƬid
	ֵ: ڴṹdrawable
	======================================================*/
	protected HFDrawableWidget convertDynamicDrawable(HFDrawableStorage ds,int[] defaultResId,int radius) {
		return convertDynamicDrawable(ds, false,null,defaultResId,radius);
	}
	/*======================================================
	: ʼؼĳԱ
	: widgetData [in] ؼ
	ֵ: ؼ
	======================================================*/
	private void initBaseMembers(Object widgetData) {
		HFBaseStorage data = (HFBaseStorage)widgetData;
		if(data != null) {
			setAlpha((short) data.getAlpha());
			setDefaultDrawable(convertDynamicDrawable(data.getDefaultDrawable()));
			setOrder((short) data.getOrder());
			setLeftOrder((short) data.getLeftOrder());
			setRightOrder((short) data.getRightOrder());
			setUpOrder((short) data.getUpOrder());
			setDownOrder((short) data.getDownOrder());
			setBinder((int)data.getBinder());
		}
	}
	/*======================================================
	: ȡؼıͼƬɫ
	:  
	ֵ: ͼƬ
	======================================================*/
	public HFDrawableWidget getDefaultDrawable() {
		return defaultDrawable;
	}
	/*======================================================
	: ÿؼĸ±־
	:  in_pDrawable     [in] ɫ
	ֵ: 
	======================================================*/
	public void setDefaultDrawable(HFDrawableWidget drawable) {
		this.defaultDrawable = drawable;
		View view = getObject();
		//if(view != null && (!(view instanceof EditText)) && drawable != null) {
		if(view != null && drawable != null) {
			if(((drawable.getEffect() & HFDrawableEffect.eDrawableEffect_Bitmap) == HFDrawableEffect.eDrawableEffect_Bitmap)
				&&(drawable.getBitmap() != null)) {
				if(getObject().getBackground() != drawable.getBitmap()) {
					getObject().setBackgroundDrawable(drawable.getBitmap());
				}
			}
			else
			if(((drawable.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) 
			   ){//&&(drawable.getColor() != -1)){
				getObject().setBackgroundColor((int)drawable.getColor());//convert2ARGB((int)drawable.getColor()));
			}
		}
	}
	
	private Drawable CreateStateDrawable(int type,int value){
		if(type == HFDrawableEffect.eDrawableEffect_Color)
			   return new ColorDrawable(value);
	    else if(type == HFDrawableEffect.eDrawableEffect_Bitmap)
			   return new HFDynamicDrawable(this,value,false,null);
		return null;
	}
	/*======================================================
	: ÿؼ״̬
	:  focus_type     [in] 0:ã1ɫЧ2ͼƬЧ
	       focus_vale     [in] ͼƬID ɫֵ
	       click_type     [in] 0:ã1ɫЧ2ͼƬЧ
	       click_value    [in] ͼƬID ɫֵ
	       enabled_type   [in] 0:ã1ɫЧ2ͼƬЧ
	       enabled_value  [in] ͼƬID ɫֵ
	ֵ: 
	======================================================*/
	public void setStateDrawable(int focus_type,int focus_vale,int click_type,int click_value,int enabled_type,int enabled_value){
		StateListDrawable sd = null;
		Drawable normald = null,focusd = null,clickd = null,disabled= null;
		HFDrawableWidget defaultDrawable = getDefaultDrawable();
		if(defaultDrawable.getEffect() == HFDrawableEffect.eDrawableEffect_Color)
		   normald = new ColorDrawable(defaultDrawable.getColor());
		else if(defaultDrawable.getEffect() == HFDrawableEffect.eDrawableEffect_Bitmap)
		   normald = defaultDrawable.getBitmap();
		else if(defaultDrawable.getEffect() == HFDrawableEffect.eDrawableEffect_Nothing)
		   normald = new ColorDrawable(Color.TRANSPARENT);
		focusd = CreateStateDrawable(focus_type,focus_vale);
		clickd = CreateStateDrawable(click_type,click_value);
		disabled = CreateStateDrawable(enabled_type,enabled_value);
		
		if(!(normald == null || focusd == null || clickd == null )) {
			sd = new StateListDrawable(); 
			sd.addState(new int[]{android.R.attr.state_focused}, focusd);  
			sd.addState(new int[]{android.R.attr.state_pressed}, clickd);  
			if(disabled != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			sd.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
		getObject().setBackgroundDrawable(sd);
	}
	
	/*======================================================
	: ÿؼ״̬
	:  normal_type    [in] 0:ã1ɫЧ2ͼƬЧ
	       normal_vale    [in] 0:ã1ɫЧ2ͼƬЧ
	       focus_type     [in] 0:ã1ɫЧ2ͼƬЧ
	       focus_vale     [in] ͼƬID ɫֵ
	       click_type     [in] 0:ã1ɫЧ2ͼƬЧ
	       click_value    [in] ͼƬID ɫֵ
	       enabled_type   [in] 0:ã1ɫЧ2ͼƬЧ
	       enabled_value  [in] ͼƬID ɫֵ
	ֵ: 
	======================================================*/
	public void setStateDrawable(int normal_type,int normal_vale,int focus_type,int focus_vale,int click_type,int click_value,int enabled_type,int enabled_value){
		StateListDrawable sd = null;
		Drawable normald = null,focusd = null,clickd = null,disabled= null;
		normald = CreateStateDrawable(normal_type,normal_vale);
		if(normald == null)
			normald = new ColorDrawable(Color.TRANSPARENT);
		focusd = CreateStateDrawable(focus_type,focus_vale);
		clickd = CreateStateDrawable(click_type,click_value);
		disabled = CreateStateDrawable(enabled_type,enabled_value);
		
		if(!(normald == null || focusd == null || clickd == null )) {
			sd = new StateListDrawable(); 
			sd.addState(new int[]{android.R.attr.state_focused}, focusd);  
			sd.addState(new int[]{android.R.attr.state_pressed}, clickd);  
			if(disabled != null) {
				sd.addState(new int[]{-android.R.attr.state_enabled}, disabled);
			}
			sd.addState(new int[]{android.R.attr.state_enabled}, normald);  
		}
		getObject().setBackgroundDrawable(sd);
	}
	
	/*======================================================
	: ȡؼ
	:  
	ֵ: ؼ
	======================================================*/
	public long getParent() {
		return WidgetParent;
	}
	/*======================================================
	: øؼ
	:  parent [in] ؼ
	ֵ: 
	======================================================*/
	public void setParent(long parent) {
		WidgetParent = parent;
	}
	/*======================================================
	: ȡؼ͸
	:  
	ֵ: ͸Ϣ
	======================================================*/
	public int getAlpha() {
		return widgetAlpha;
	}
	/*======================================================
	: ÿؼ͸
	:   in_ucAlpha    [in] alpha
	ֵ: 
	======================================================*/	
	public void setAlpha(int alpha) {
		widgetAlpha = (short) alpha;
	}
	public int getModeId() {
		return mModeId;
	}
	public void setModeId(int modeId) {
		this.mModeId = modeId;
	}
	
	//ȡDrawable
	private Drawable getDrawable(Context context, HFDrawableStorage ds) {
		Drawable drawable = null;
		if(ds != null) {
			int bitmapId = ds.getBitmap();
			HFOnLaunchDrawableInterface launcher = HFModesManager.getOnLaunchDrawableListener();
			if(launcher != null && bitmapId > 0){
				drawable = launcher.OnLaunchDrawable(bitmapId);
				HFWidgetBound bound = this.getBound();
				if(drawable != null && bound != null) {
					drawable.setBounds(	bound.getLeft(), bound.getTop(),
										bound.getLeft() + bound.getWidth() - 1,
										bound.getTop() + bound.getHeight() - 1);
				}
			}
			else
			if((ds.getEffect()&HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) {
				drawable = new ColorDrawable(ds.getColor());
				HFWidgetBound bound = this.getBound();
				if(drawable != null && bound != null) {
					drawable.setBounds(	bound.getLeft(), bound.getTop(),
										bound.getLeft() + bound.getWidth() - 1,
										bound.getTop() + bound.getHeight() - 1);
				}
			}
		}
		return drawable;
	} 
	//Drawable
	protected Drawable getDrawable(HFDrawableStorage ds) {
		return getDrawable(getObject().getContext(), ds);
	} 
	//Drawable
	protected Drawable getDrawable(HFDrawableWidget dw) {
		return getDrawable(dw,0);
	} 
	//Drawable
	protected Drawable getDrawable(HFDrawableWidget dw, int radius) {
		Drawable drawable = null;
		if(dw != null) {
			if((dw.getEffect() & HFDrawableEffect.eDrawableEffect_Bitmap) == HFDrawableEffect.eDrawableEffect_Bitmap) {
				drawable = dw.getBitmap();
			}else if((dw.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color){
				if(radius > 0){
					drawable = new HFCircleColorDrawable(dw.getColor(),radius);
				}else{
					drawable = new ColorDrawable(dw.getColor());
				}
			}
		}
		return drawable;
	} 		
	/*======================================================
	: ȡؼlistener
	:  
	ֵ: listenerָ
	======================================================*/
	public HFOnWidgetClickInterface getOnClickListener() {
		return mOnClickListener;
	}
	/*======================================================
	: ÿؼlistener
	:  listener      [in] listener
	ֵ: =0: ɹ; >0: 
	======================================================*/
	public void setOnClickListener(HFOnWidgetClickInterface listener) {
		mOnClickListener = listener;
		if(getObject() != null) {
			HFModeWidget mode = HFModesManager.getCurrentMode();
			mModeId = mode.getModeId();
			getObject().setOnClickListener(new HFOnClickeListener(this));
		}
	}
	
	/*======================================================
	: ȡؼlistener
	:  
	ֵ: listenerָ
	======================================================*/
	public HFOnWidgetLongClickInterface getOnLongClickListener() {
		return mOnLongClickListener;
	}
	/*======================================================
	: ÿؼlistener
	:  listener      [in] listener
	ֵ: =0: ɹ; >0: 
	======================================================*/
	public void setOnLongClickListener(HFOnWidgetLongClickInterface listener) {
		mOnLongClickListener = listener;
		if(getObject() != null) {
			getObject().setOnLongClickListener(new HFOnLongClickeListener(this));
		}
	}
	/*======================================================
	: ȡؼtag
	:  widget  [in] ؼָ
	ֵ: tag
	======================================================*/	
	public Object getTag() {
		return getObject().getTag();
	}
	/*======================================================
	: ÿؼag
	:  widget        [in] ؼָ
	       in_pvTag      [in] tag
	ֵ: =0: ɹ; >0: 
	======================================================*/
	public void setTag(Object tag) {
		this.getObject().setTag(tag);
	}
	/*======================================================
	: ȡؼĿñ־
	:  widget  [in] ؼָ
	ֵ: ñ־
	======================================================*/	
	public boolean getEnabled() {
		if(this.getObject() != null)
		  return this.getObject().isEnabled();
		return false;
	}
	/*======================================================
	: ÿؼĿñ־
	:  enabled  [in] ñ־
	ֵ:  =0: ɹ; >0: 
	======================================================*/	
	public void setEnabled(boolean enabled) {
		if(this.getObject() != null)
		  this.getObject().setEnabled(enabled);
	}
	/*======================================================
	: ȡؼĿӱ־
	:  widget  [in] ؼָ
	ֵ: ӱ־
	======================================================*/
	public boolean getVisible() {
		if(this.getObject() != null)
		  return (this.getObject().getVisibility() == View.VISIBLE);
		return mVisible;
	}
	/*======================================================
	: ÿؼĿӱ־
	:  visible  [in] ӱ־
	ֵ: =0: ɹ; >0: 
	======================================================*/		
	public void setVisible(boolean visible) {
		int visibility = (visible) ? View.VISIBLE : View.INVISIBLE;
		if(this.getObject() != null)
		   this.getObject().setVisibility(visibility);
		mVisible = visible;
	}
	/*======================================================
	: ÿؼĿӱ־
	:  visibility  [in] ӱ־
	======================================================*/		
	public void setVisibility(int visibility) {
		if(this.getObject() != null)
		   this.getObject().setVisibility(visibility);
		mVisible = visibility == View.VISIBLE;
	}
	/*======================================================
	: ˢ¿ؼ
	:  
	ֵ: 
	======================================================*/		
	public void update() {
		View view =	this.getObject();
		if(view != null) {
			view.invalidate();
		}
	}	
	/*======================================================
	: ȡؼOrder
	:  
	ֵ: Order
	======================================================*/	
	public int getOrder() {
		return order;
	}
	/*======================================================
	: ÿؼOrder
	:  order [in] Order
	ֵ: 
	======================================================*/	
	public void setOrder(int order) {
		this.order = (short) order;
	}
	/*======================================================
	: ȡؼLeftOrder
	:  
	ֵ: LeftOrder
	======================================================*/		
	public int getLeftOrder() {
		return leftOrder;
	}
	/*======================================================
	: ÿؼLeftOrder
	:  order [in] LeftOrder
	ֵ: 
	======================================================*/	
	public void setLeftOrder(int order) {
		this.leftOrder = (short) order;
	}
	/*======================================================
	: ȡؼRightOrder
	:  
	ֵ: RightOrder
	======================================================*/		
	public int getRightOrder() {
		return rightOrder;
	}
	/*======================================================
	: ÿؼRightOrder
	:  order [in] RightOrder
	ֵ: 
	======================================================*/	
	public void setRightOrder(int order) {
		this.rightOrder = (short) order;
	}
	/*======================================================
	: ȡؼUpOrder
	:  
	ֵ: UpOrder
	======================================================*/		
	public int getUpOrder() {
		return upOrder;
	}
	/*======================================================
	: ÿؼUpOrder
	:  order [in] UpOrder
	ֵ: 
	======================================================*/	
	public void setUpOrder(int order) {
		this.upOrder = (short) order;
	}
	/*======================================================
	: ȡؼDownOrder
	:  
	ֵ: DownOrder
	======================================================*/		
	public int getDownOrder() {
		return downOrder;
	}
	/*======================================================
	: ÿؼDownOrder
	:  order [in] DownOrder
	ֵ: 
	======================================================*/	
	public void setDownOrder(int order) {
		this.downOrder = (short) order;
	}	

	/*======================================================
	: ʵֿؼĺл
	: 	widgetData  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
	protected int changeOrientation(HFBaseStorage widgetData) {
		if(widgetData != null) {
			setBound(widgetData.getBound());
		}
		return 0;
	}
	/*======================================================
	: ʵֿؼĺл
	: 	widget  [in] ؼ
	ֵ: =0: лɹ; >0: 
	======================================================*/
	protected int changeOrientation(HFBaseWidget widget) {
		if(widget != null) {
			setBound(widget.getBound());
		}
		return 0;
	}	
	public HFOnWidgetDrawInterface getOnDrawListener() {
		return mOnDrawListener;
	}
	public void setOnDrawListener(HFOnWidgetDrawInterface listener) {
		this.mOnDrawListener = listener;
	}
	// added by LiangYJ 20150702
	public HFOnWidgetDrawAfterInterface getOnDrawAfterListener() {
		return mOnDrawAfterListener;
	}
	public void setOnDrawAfterListener(HFOnWidgetDrawAfterInterface listener) {
		this.mOnDrawAfterListener = listener;
	}
	//end
	/*======================================================
	:  ؼ¼Ӧ
	:  sender   [in]  ¼Դ
	ֵ:FALSE: ¼δ; 
	       TRUE:¼Ѵ
	======================================================*/
	public interface HFOnWidgetClickInterface {
		public void onClick(HFBaseWidget sender);
	}
	/*======================================================
	:  ؼ¼Ӧ
	:  sender   [in]  ¼Դ
	ֵ:FALSE: ¼δ; 
	       TRUE:¼Ѵ
	======================================================*/
	public interface HFOnWidgetLongClickInterface {
		public void onLongClick(HFBaseWidget sender);
	}
	/*======================================================
	:  ؼ¼ƺ
	:  	sender         	[in]  ¼Դ
			canvas			[in]  	
	ֵ:FALSE: ¼δ; 
	       TRUE: ¼Ѵ
	======================================================*/
	//typedef HF_RESULT (*pfnNAVI_HF_ONWIDGETDRAW_LISTENER)(void *sender);
	public interface HFOnWidgetDrawInterface {
		public boolean onDraw(HFBaseWidget sender, Canvas canvas);
	}
	/*======================================================
	:  ֮Ļص
	:  	sender         	[in]  ¼Դ
			canvas			[in]  	
	ֵ:FALSE: ¼δ; 
	       TRUE: ¼Ѵ
	======================================================*/
	//typedef HF_RESULT (*pfnNAVI_HF_ONWIDGETDRAW_LISTENER)(void *sender);
	public interface HFOnWidgetDrawAfterInterface {
		public boolean onDrawAfter(HFBaseWidget sender, Canvas canvas);
	}
	//ػViewؼ¼ɷԶؼ
	protected class HFOnClickeListener implements OnClickListener {
		private HFBaseWidget mWidget = null;
		public HFOnClickeListener(HFBaseWidget widget) {
			mWidget = widget;
		}
		@Override
		public void onClick(View v) {
			if(v == null || v.getContext() == null)
				return;
			//HFSlideMenu.m_MenuModeId
			HFModeWidget mode = HFModesManager.getCurrentMode();
			HFSlideMenu menu = mode.getSlideMenu();
			if((mWidget != null && mModeId == HFModesManager.getCurrentMode().getModeId()) || menu.getCurrentScreen() == HFSlideMenu.SCREEN_MENU) {
				HFOnWidgetClickInterface listener = mWidget.getOnClickListener();
				if(listener != null) {
					long currentTime = System.currentTimeMillis();
					long timeInterval = onClickTimeInterval;
					if(timeInterval <= 0)
						timeInterval = HFModesManager.getOnClickTimeInterval();
					if(mClickStorage == null)
						mClickStorage = new HFAnalyticsClickStorage();
					if(HFModesManager.getCurrentMode() != null)
					    mClickStorage.setModeName(HFModesManager.getCurrentMode().getName());
					if(Math.abs(currentTime - backupOnClickTime) > timeInterval || mQuickClickable)
					{
					  listener.onClick(mWidget);
					  if(mWidget instanceof HFEditWidget){
						  HFModesManager.resetLayoutOnCurrentMode = false;
					  }else{
						  HFModesManager.resetLayoutOnCurrentMode = true;
					  }
					  backupOnClickTime = System.currentTimeMillis();
					}
					
					if(HFModesManager.getAnalyticsListener() != null){
						mClickStorage.setWidgetName(getName());
						mClickStorage.setCostTime(System.currentTimeMillis() - currentTime);
						HFModesManager.getAnalyticsListener().onGetClickMsg(mClickStorage);
					}
				}
			}
		}
	}
	
	//ػViewؼĳ¼¼ɷԶؼ
		protected class HFOnLongClickeListener implements OnLongClickListener {
			private HFBaseWidget mWidget = null;
			public HFOnLongClickeListener(HFBaseWidget widget) {
				mWidget = widget;
			}
			@Override
			public boolean onLongClick(View v) {
				if(mWidget != null) {
					HFOnWidgetLongClickInterface listener = mWidget.getOnLongClickListener();
					if(listener != null) {
						listener.onLongClick(mWidget);
						return true;
					}
				}
				return false;
			}
		}
	
	/*======================================================
	:  ƽƶ
	:  fromXValue  [in] Xʼ
	       toXValue    [in] X
	       fromYValue  [in] Yʼ
	       toYValue    [in] Y
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startTranslateAnimation(float fromXValue, float toXValue, float fromYValue, float toYValue,long durationMillis,Interpolator interpolator,AnimationListener listener){
		TranslateAnimation mAnimation = HFAnimationFactory.getTranslateAnimation(fromXValue, toXValue, fromYValue, toYValue, durationMillis,interpolator,listener);
		getObject().startAnimation(mAnimation);
	}
	
	/*======================================================
	: Ŷ
	:  fromX      [in]  [0,1]Xűʼֵ
	       toX        [in]  [0,1]Xűֵ
	       fromY      [in]  [0,1]Yűʼֵ
	       toY        [in]  [0,1]Yűֵ
	       pivotX     [in]  ĵX[0ؼwidth]
	       pivotY     [in]  ĵY[0ؼ߶height]
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startScaleAnimation(float fromX, float toX, float fromY, float toY, float pivotX, float pivotY,long durationMillis,Interpolator interpolator,AnimationListener listener){
		ScaleAnimation mAnimation = HFAnimationFactory.getScaleAnimation(fromX, toX, fromY, toY, pivotX, pivotY, durationMillis,interpolator,listener);
		getObject().startAnimation(mAnimation);
	}
	
	/*======================================================
	:  ͸ȶ
	:  fromAlpha   [in]  ʼAlphaֵ
	       toAlpha     [in]  Alphaֵ
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startAlphaAnimation(float fromAlpha, float toAlpha,long durationMillis,Interpolator interpolator,AnimationListener listener){
		AlphaAnimation mAnimation = HFAnimationFactory.getAlphaAnimation(fromAlpha, toAlpha, durationMillis,interpolator,listener);
		getObject().startAnimation(mAnimation);
	}
	
	/*======================================================
	: ת̬
	:  fromDegrees   [in]  ʼǶ[0,360]
	       toDegrees     [in]  Ƕ[0,360]
	       pivotXValue   [in]  תĵX[0ؼwidth]
	       pivotYValue   [in]  ĵY[0ؼ߶height]
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startRotateAnimation(float fromDegrees, float toDegrees, float pivotXValue, float pivotYValue,long durationMillis,Interpolator interpolator,AnimationListener listener){
		RotateAnimation mAnimation = HFAnimationFactory.getRotateAnimation(fromDegrees, toDegrees, pivotXValue, pivotYValue, durationMillis,interpolator,listener);
		getObject().startAnimation(mAnimation);
	}
	public long getOnClickTimeInterval() {
		return onClickTimeInterval;
	}
	public void setOnClickTimeInterval(long onClickTimeInterval) {
		this.onClickTimeInterval = onClickTimeInterval;
	}
	public int getBinder() {
		return binder;
	}
	/*======================================================
	:  ð󶨱־λ
	:  binder
	ֵ:
	======================================================*/
	public void setBinder(int binder) {
		this.binder = binder;
	}
	
	/**
	 * ÿؼѡ״̬
	 * @param selected
	 */
	public void setSelected(boolean selected){
		if(getObject() != null){
			getObject().setSelected(selected);
			getObject().invalidate();
		}
	}
	
	/** ǷԿٵ
	 * @param quickClickable
	 * @return void
	 * @author LiangYJ
	 * @date 2015-11-3 6:43:04
	 */ 
	public void setQuickClickable(boolean quickClickable){
		mQuickClickable = quickClickable;
	}
}
