/*
 * @Title HFCustomAbsoluteLayout.java
 * @Copyright Copyright 2010-2015 Careland Software Co,.Ltd All Rights Reserved.
 * @author LiangYJ
 * @date 20171024 10:21:16
 * @version 1.0
 */
package cnv.hf.widgets;

import java.util.Vector;

import android.content.Context;
import android.os.Build;
import android.util.AttributeSet;
import android.util.Log;
import android.widget.AbsoluteLayout;
import android.widget.Toast;

/**
 * ⰴľԲ
 * 
 * @author LiangYJ
 * @date 20171024 10:21:16
 */
public class HFCustomAbsoluteLayout extends AbsoluteLayout {

	private boolean isFirst = true;
	private HFICustomAbsoluteListener listener;
	private int lastHeight = 0;
	private int lastWidth = 0;
	
	/**
	 * @param context
	 * @param attrs
	 */
	public HFCustomAbsoluteLayout(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	/**
	 * @param context
	 * @param attrs
	 */
	public HFCustomAbsoluteLayout(Context context) {
		super(context);
	}

	/** òּ
	 * @param listener
	 * @author LiangYJ
	 * @date 20171024 11:29:52
	 */ 
	public void setLayoutListener(HFICustomAbsoluteListener listener){
		this.listener = listener;
	}

	/**
	 * @see android.widget.AbsoluteLayout#onLayout(boolean, int, int, int, int)
	 */
	@SuppressWarnings("deprecation")
	@Override
	protected void onLayout(boolean changed, int l, int t, int r, int b) {
		// TODO Auto-generated method stub
		super.onLayout(changed, l, t, r, b);
		if (changed) {
			int width = HFModesManager.getScreenWidth();
			int height = HFModesManager.getScreenHeight();
			if(Build.VERSION.SDK_INT >= 24 && Build.MANUFACTURER.equalsIgnoreCase("Xiaomi")){
				if (width > 0 && height > 0) {
					if(b - t > height){
						isFirst = false;
					}
				}
			}
			if(!isFirst){
				if (width > 0 && height > 0) {
					if(lastHeight == 0){
						lastHeight = b - t;
					}
					if(lastWidth == 0){
						lastWidth = r - l;
					}
					if(Build.VERSION.SDK_INT >= 24 && Build.MANUFACTURER.equalsIgnoreCase("Xiaomi")){

						if(width > height){
//							int temp = lastHeight;
							lastHeight = height;
							lastWidth = width;
						}
						
						if(Build.VERSION.SDK_INT < 26 && HFModesManager.getMapMode() != null){
							Vector<HFModeFragment> fragments = HFModesManager.getMapMode().getFragmentStacks();
							if(fragments != null && fragments.size() > 1){
								return;
							}
						}
//						if((r - l) > width || (b - t) > height)
//							return;
//						if((b - t) > height * 0.9 && lastHeight > height * 0.6)
//							return;
					}
					if (((r - l) > width * 0.8) && ((b - t) > height * 0.8)
							&& lastHeight > height * 0.8
							&& lastWidth > width * 0.8) {// ų̵
						if (listener != null) {
							Log.i("framwork", "onLayoutChanged--1--");
							listener.onLayoutChanged(l, t, r, b);
							lastHeight = b - t;
							lastWidth = r - l;
						}
					}else if(Build.VERSION.SDK_INT >= 24 && Build.MANUFACTURER.equalsIgnoreCase("HUAWEI")){
						HFModesManager.shouldResetScreenOnFrameCreate = true;
						lastHeight = b - t;
						lastWidth = r - l;
					}
					if(Build.VERSION.SDK_INT >= 24){
						if(!Build.MANUFACTURER.equalsIgnoreCase("OPPO") || Build.VERSION.SDK_INT > 26) {
							lastHeight = b - t;
							lastWidth = r - l;
						}
					}
				}
			}
			isFirst = false;
		}
	}
	
	public interface HFICustomAbsoluteListener {
		public void onLayoutChanged(int l, int t, int r, int b);
	}
}
