package cnv.hf.widgets;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.util.AttributeSet;
import android.widget.ImageView;
import cnv.hf.widgets.HFDrawableWidget.HFDrawableEffect;
import cnv.hf.widgets.HFWidgetStorage.HFDrawableStorage;
import cnv.hf.widgets.HFWidgetStorage.HFImageStorage;

public class HFImageWidget extends HFBaseWidget{

	//private ImageView mObject = null;
	//private Drawable imageDrawable = null;
	public HFImageWidget(Context context, Object widgetData) {
		super(context, widgetData);
		initImageMembers(widgetData);
	}
	@Override
	protected void setHolder(Context context,Object widgetData) {
		HFImageView iv = new HFImageView(context);
		iv.setHolder(this);
		setObject(iv);
	}
	//@Override
	private void initImageMembers(Object widgetData) {

		HFImageStorage data = (HFImageStorage)widgetData;
		if(data != null) {
			HFDrawableWidget drawable = null;
			HFDrawableStorage ds = data.getImage();
			if(ds.getEffect() == HFDrawableEffect.eDrawableEffect_Nothing) {
				drawable = getDefaultDrawable();
			}
			else {
				drawable = convertDynamicDrawable(ds, false,null);
			}
			if(drawable != null) {
				if(drawable.getBitmap() != null) {
					setImageDrawable(drawable.getBitmap());
				}
				else
				if((drawable.getEffect()& HFDrawableEffect.eDrawableEffect_Color) ==  HFDrawableEffect.eDrawableEffect_Color) {

					if(data.getRadius() > 0){
						setImageDrawable(new HFCircleColorDrawable(drawable.getColor(), data.getRadius()));
					}else{
						setImageDrawable(new ColorDrawable(drawable.getColor()));
					}
					
				}	
			}
		}
		setDefaultDrawable(null);
		getObject().setBackgroundDrawable(null);
		return ;
	}
	public Drawable getImageDrawable() {
		return ((ImageView)getObject()).getDrawable();
	}
	public void setImageDrawable(Drawable drawable) {
		ImageView iv = (ImageView)getObject();
		if(	(drawable == null) 
				|| (drawable != null 
					&& iv.getDrawable() != drawable)) {
			iv.setImageDrawable(drawable);
		}
	}	
	//HFImageView
    protected class HFImageView extends ImageView {
    	private HFImageWidget mHolder = null;
    	
        public HFImageView(Context context, AttributeSet attrs, int defStyle) {  
            super(context, attrs, defStyle);  
        }  
        public HFImageView(Context context, AttributeSet attrs) {  
            super(context, attrs);  
        }  
        public HFImageView(Context context) {  
            super(context);  
        }
        @SuppressLint("WrongCall")
		@Override
        protected void onDraw(Canvas canvas) {
        	HFImageWidget holder = this.getHolder();
        	if(holder != null) {
        		HFOnWidgetDrawInterface listener = holder.getOnDrawListener();
        		if(listener != null) {
        			try{
	        			if(listener.onDraw(holder, canvas)) {
	        				return ;
	        			}
        			}catch(Exception e){
                		
                	}
        		}
        	}
            super.onDraw(canvas);
            
            // added by LiangYJ 20150702
            if(holder != null) {
        		HFOnWidgetDrawAfterInterface listener = holder.getOnDrawAfterListener();
        		if(listener != null) {
        			try{
	        			if(listener.onDrawAfter(holder, canvas)) {
	        				return ;
	        			}
        			}catch(Exception e){
                		
                	}
        		}
        	}
            //end
        }        
		protected HFImageWidget getHolder() {
			return mHolder;
		}
		protected void setHolder(HFImageWidget holder) {
			this.mHolder = holder;
		} 
    }
}
