package cnv.hf.widgets;

import java.util.ArrayList;
import java.util.Vector;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.StateListDrawable;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.Interpolator;
import android.view.animation.RotateAnimation;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;
import android.widget.AbsoluteLayout;
import android.widget.Toast;
import cnv.hf.widgets.HFDrawableWidget.HFDrawableEffect;
import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetStorage.HFDrawableStorage;
import cnv.hf.widgets.HFWidgetStorage.HFExpandableListStorage;
import cnv.hf.widgets.HFWidgetStorage.HFLayerStorage;
import cnv.hf.widgets.HFWidgetStorage.HFSliderStorage;
import cnv.hf.widgets.HFWidgetStorage.HFSwitchStorage;
import cnv.hf.widgets.HFWidgetStorage.HFTextItemStorage;
import cnv.hf.widgets.HFWidgetsManager.HFWidgetType;

@SuppressWarnings("deprecation")
public class HFLayerWidget extends AbsoluteLayout{

	private HFLayerStorage mLayerData = null; 
	private Context mContext = null;
	private Vector<HFBaseWidget> mWidgets = null;
	private long mTagEx = -1;
	//ڼ¼ͼϴбĸ,ںл
	private int mListWidgetCount = 0;
	//ͼǷװ˿ؼ
	private boolean mIsReady = false;
	private int	mLayerId = 0;
	private int defaultColor = Color.TRANSPARENT;
	private ILayerDrawListener mDraw;
	private byte b2VeiledEffect = 0;                 /*ɴЧ*/
	/** Ⲽֱ䶯ⰴлʾص²ִҵ*/
	private boolean checkLayoutSizeChange = false;
	
	public HFLayerWidget(Context context) {
		super(context);	
		mContext = context;
		mLayerData = new HFLayerStorage();
		mWidgets = new Vector<HFBaseWidget>();	
		mListWidgetCount = 0;
		//setDescendantFocusability(FOCUS_BLOCK_DESCENDANTS);
	}
	public HFLayerWidget(Context context,boolean checkLayoutSizeChange) {
		super(context);	
		mContext = context;
		mLayerData = new HFLayerStorage();
		mWidgets = new Vector<HFBaseWidget>();	
		mListWidgetCount = 0;
		this.checkLayoutSizeChange = checkLayoutSizeChange;
		//setDescendantFocusability(FOCUS_BLOCK_DESCENDANTS);
	}
	public HFLayerWidget(Context context, Object widgetData) {
		super(context);
		
		mContext = context;
		mLayerData = (HFLayerStorage)widgetData;
		mWidgets = new Vector<HFBaseWidget>();
		//ʼͼ
		initLayerMembers(widgetData);
	}	
	public HFLayerWidget(Context context, AttributeSet attrs) {
		super(context, attrs);
		mContext = context;
		mLayerData = new HFLayerStorage();
		mWidgets = new Vector<HFBaseWidget>();	
	}	
	public HFLayerWidget(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		
		mContext = context;
		mLayerData = new HFLayerStorage();
		mWidgets = new Vector<HFBaseWidget>();	
	}
	/*======================================================
	: ʼؼĳԱ
	: widgetData [in] ؼ
	ֵ: ؼ
	======================================================*/
	private void initLayerMembers(Object widgetData) {
		HFLayerStorage data = (HFLayerStorage)mLayerData;
		setStateDrawable(data);
	}
	
	/*======================================================
	: ðť״̬ͼƬ
	:   btnStatus [in] ť״̬
	        drawable  [in] ͼƬ
	ֵ: ť״̬ͼƬ
	======================================================*/
    private void setStateDrawable(HFLayerStorage data) {
    	if(data != null) {
    		b2VeiledEffect = data.getB2VeiledEffect();
			//int visibility = (data.getVisible() == 1) ? View.VISIBLE : View.INVISIBLE;
			//this.setVisibility(visibility);
			//dinghu  2015_6_12 ͼ㱳
			HFDrawableStorage draws = data.getDefaultDrawable();
			if ((draws.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) {
//				this.setBackgroundColor(draws.getColor());
				StateListDrawable sd = getBackGroundListDrawable(draws);
	    	    if(sd != null) {
	    		    setBackgroundDrawable(sd);
	    	    }
				Log.d("SDK", "initLayerMembers color");
			}
			
		}
		return ;
    } 
    
    /*======================================================
	: ȡť״̬ͼƬ
	:  
	ֵ: ť״̬ͼƬ
	======================================================*/
	public  StateListDrawable getBackGroundListDrawable(HFDrawableStorage draws) {
		
		StateListDrawable sd = null;		
		Drawable normald = new ColorDrawable(draws.getColor());
		//added by LiangYJ 20150616 Ĭϵɫ
		Drawable clickd = new ColorDrawable(defaultColor);

		if(!(normald == null || clickd == null )) {
			sd = new StateListDrawable(); 
//			sd.addState(new int[]{android.R.attr.state_pressed}, clickd);  
			sd.addState(new int[]{android.R.attr.state_enabled}, normald); 
		}
		//end
    	return sd;	
	}
	
	//added by LiangYJ 20150706
    /*======================================================
	: ȡť״̬ͼƬ
	:  
	ֵ: ť״̬ͼƬ
	======================================================*/
	public  StateListDrawable getBackGroundListDrawable() {
		
		HFLayerStorage data = (HFLayerStorage)mLayerData;
		if(data != null) {
			//dinghu  2015_6_12 ͼ㱳
			HFDrawableStorage draws = data.getDefaultDrawable();
			if ((draws.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) {
//				this.setBackgroundColor(draws.getColor());
				return getBackGroundListDrawable(draws);
			}else if ((draws.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Nothing) {
//				this.setBackgroundColor(draws.getColor());
				return getBackGroundListDrawable(draws);
			}
			
		}
		
    	return null;	
	}
	//end
	
	public int getDefaultColor(){
		HFLayerStorage data = (HFLayerStorage)mLayerData;
		if(data != null) {
			HFDrawableStorage draws = data.getDefaultDrawable();
			if ((draws.getEffect() & HFDrawableEffect.eDrawableEffect_Color) == HFDrawableEffect.eDrawableEffect_Color) {
				return draws.getColor();
			}
		}
		return -1;
	}
	
	/*=======================================================
	:
		Կؼ
	:
		bound [in] ԭʼ
		deltaXY [in] ƫ
	ֵ:
	˵:
		ʱֻ꣬ſؼĿ
	=======================================================*/	
	protected void scaleCoords(HFWidgetBound bound, HFWidgetPoint deltaXY) {
		if(bound != null && deltaXY != null && HFModesManager.isScaleMode()) {
			bound.setLeft(bound.getLeft() + deltaXY.X);
			bound.setTop(bound.getTop() + deltaXY.Y);
		}
	}
	/*======================================================
	: ӿؼ
	:  widget       [in] ҪӵĿؼ
	
	ֵ: =0: óɹ; >0:  ; =1 ʾеͼؼ
	======================================================*/
	protected int loadWidgets(HFModeWidget mode, HFModeLoader modeLoader) {
		boolean containMapView = false;
		if(mLayerData == null && modeLoader == null) {
			return HFErrorCode.HF_ERROR_WIDGET_MEMBERS_INVALID;
		}
		int numWidgets = mLayerData.getNumOfWidgets();
		int layerId = mLayerData.getId();
		HFWidgetsManager widgetsMan = new HFWidgetsManager(mContext);
		HFBaseObject widget = null;
		//λؼָ
		modeLoader.reset();
		for(int index = 0; index < numWidgets; index++) {
			HFBaseStorage widgetData = modeLoader.getNextWidgetData(layerId);
			if(widgetData != null && widgetData.getType() != HFWidgetType.eWidgetType_MapView) {
				int fixedshape = widgetData.getFixedShapeEnabled();
				//
				mode.scaleCoords(widgetData.getBound(),fixedshape);
				if(widgetData instanceof HFTextItemStorage){
					HFTextItemStorage mTextItem = (HFTextItemStorage)widgetData;
					float xScale = mode.getXScaleFactor();
					float yScale = mode.getYScaleFactor();
					float minScale = Math.min(xScale, yScale);
					if(HFModesManager.isScaleMode()) {
					mTextItem.getMargin().setLeft((short)Math.ceil(mTextItem.getMargin().getLeft()* xScale));
					mTextItem.getMargin().setRight((short)Math.ceil(mTextItem.getMargin().getRight() * xScale));
					mTextItem.getMargin().setTop((short)Math.ceil(mTextItem.getMargin().getTop() * yScale));
					mTextItem.getMargin().setBottom((short)Math.ceil(mTextItem.getMargin().getBottom() * yScale));
					//С
					mTextItem.getFont().setSize((float)Math.ceil(minScale * mTextItem.getFont().getSize()));
					}
				}
				if(widgetData instanceof HFSwitchStorage){
					HFSwitchStorage mSwitchStorage = (HFSwitchStorage)widgetData;
					mode.scaleCoords(mSwitchStorage.getSwitchBound(),fixedshape);
				}
				if(widgetData instanceof HFExpandableListStorage){
					HFExpandableListStorage mListStorage = (HFExpandableListStorage)widgetData;
					for(int i = 0; i < mListStorage.getNumOfListItems();i++)
						mode.scaleCoords(mListStorage.getItem(i).getBound(),fixedshape);
				}
				if(widgetData instanceof HFSliderStorage){
					float xScale = mode.getXScaleFactor();
					float yScale = mode.getYScaleFactor();
					HFSliderStorage mSliderStorage = (HFSliderStorage)widgetData;
					mode.scaleCoords(mSliderStorage.getButton().getBound(),fixedshape);
					if(mSliderStorage.getUpOrder() >=0)
					  mSliderStorage.setUpOrder((int)(mSliderStorage.getUpOrder() * yScale));
					if(mSliderStorage.getDownOrder() >= 0)
					  mSliderStorage.setDownOrder((int)(mSliderStorage.getDownOrder() * yScale));
					if(mSliderStorage.getLeftOrder() >=0)
					  mSliderStorage.setLeftOrder((int)(mSliderStorage.getLeftOrder() * xScale));
					if(mSliderStorage.getRightOrder() >= 0)
					  mSliderStorage.setRightOrder((int)(mSliderStorage.getRightOrder() * xScale));
					
				}
				widget = (HFBaseObject) widgetsMan.createWidget(widgetData.getType(), widgetData);
				if(widget != null) {
					//¼бؼĸ
					if(widget.getType() == HFWidgetType.eWidgetType_List) {
						mListWidgetCount++;
					} 
					widget.setLayout(this);
					addWidget(widget,-1,-1);
				}
			}
			if(widgetData != null && widgetData.getType() == HFWidgetType.eWidgetType_MapView){
				containMapView = true;
			}
		}
		setIsReady(true);
		//ťͼƬİ󶨹ϵ
		setBinderRelationship();
		return containMapView == true?HFErrorCode.HF_SUCCESS + 1:HFErrorCode.HF_SUCCESS;
	}
	
	/*======================================================
	: ButtonImageListİ󶨹ϵ
	:  
	
	ֵ:
	======================================================*/
	public void setBinderRelationship(){
		for(int i = 0; i < mWidgets.size(); i++){
			HFBaseWidget widget = mWidgets.get(i);
			if(widget.getType() == HFWidgetType.eWidgetType_ImageList && widget.getBinder() > 0)
			{
				for(int j = 0; j < mWidgets.size(); j++){
					HFBaseWidget bindwidget = mWidgets.get(j);
					if(bindwidget.getBinder() == widget.getBinder() && bindwidget.getType() == HFWidgetType.eWidgetType_Button)
					{
						HFButtonWidget btnwidget = (HFButtonWidget)mWidgets.get(j);
						btnwidget.setBinderImageListWidget((HFImageListWidget)widget);
					}
				}
			}
		}
	}
	/*======================================================
	: ӿؼ
	:  widget       [in] ҪӵĿؼ
	
	ֵ: =0: óɹ; >0: 
	======================================================*/
	public int addWidget(Object widget,int originalChildIndex,int hfwidgetIndex) {
		
		HFBaseWidget base = ((HFBaseWidget)widget);
		
		if(base == null) {
			return HFErrorCode.HF_ERROR_WIDGET_INVALID;
		}
		HFWidgetBound widgetBound = base.getBound();
		if(widgetBound == null) {
			return HFErrorCode.HF_ERROR_WIDGET_MEMBERS_INVALID;
		}
		int w = widgetBound.getWidth();
		int h = widgetBound.getHeight();
		int l = widgetBound.getLeft();
		int t = widgetBound.getTop();
		
		//ͼϵĿؼ꣬Ҫȥͼ
		HFWidgetBound layerBound = getBound();
		if(layerBound != null) {
			l -= layerBound.getLeft();
			t -= layerBound.getTop();
		}
		LayoutParams params = new LayoutParams(w, h, l, t); 
		if(base.getObject()!= null){
		  ViewGroup parent = (ViewGroup) base.getObject().getParent();
		  if (parent != null) { 
			 parent.removeAllViews();
		  } 
		  if(originalChildIndex >= 0)
			addView(base.getObject(),originalChildIndex,params);
		  else
		    addView(base.getObject(), params);
		}
		if(hfwidgetIndex >= 0)
		  mWidgets.add(hfwidgetIndex,(HFBaseWidget) widget);
		else
		  mWidgets.add((HFBaseWidget) widget);
		return HFErrorCode.HF_SUCCESS;
	}
	
	/*======================================================
	: ӿؼ
	:  widget       [in] ҪӵĿؼ
	
	ֵ: =0: óɹ; >0: 
	======================================================*/
	public void reLayoutWidget(int index){
        HFBaseWidget base = ((HFBaseWidget)mWidgets.get(index));
		HFWidgetBound widgetBound = base.getBound();
	
		int w = widgetBound.getWidth();
		int h = widgetBound.getHeight();
		int l = widgetBound.getLeft();
		int t = widgetBound.getTop();
		
		//ͼϵĿؼ꣬Ҫȥͼ
		HFWidgetBound layerBound = getBound();
		if(layerBound != null) {
			l -= layerBound.getLeft();
			t -= layerBound.getTop();
		}
		LayoutParams params = new LayoutParams(w, h, l, t); 
		base.getObject().setLayoutParams(params);
	}
	
	/*======================================================
	: ӿؼ
	:  widget       [in] ҪӵĿؼ
	
	ֵ: =0: óɹ; >0: 
	======================================================*/
	public void addWidget(View widget, HFWidgetBound bound,int index) {
		
		int w = bound.getWidth();
		int h = bound.getHeight();
		int l = bound.getLeft();
		int t = bound.getTop();
		
		LayoutParams params = new LayoutParams(w, h, l, t); 
		if(widget != null){
		  if(index >= 0)
			addView(widget, index,params);
		  else
		    addView(widget, params);
		}
	}
	/*======================================================
	: ͨӿؼIdȡӿؼ
	:  
			id   [in] ӿؼid
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget findWidgetById(int id) {
		synchronized(mWidgets)
		{
			int index;
			HFBaseWidget widget = null;
			for(index = 0; index < mWidgets.size(); index++) {
				widget = mWidgets.get(index);
				if((widget != null) && (widget.getId() == id)) {
					return widget;
				}
			}
		}
		return null;
	}	
	/*======================================================
	: ͨӿؼƻȡӿؼ
	:  
			in_cWidgetName   [in] ӿؼ
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget findWidgetByName(String widgetName) {
		synchronized(mWidgets)
		{
			int index;
			HFBaseWidget widget = null;
			if(TextUtils.isEmpty(widgetName))
				return null;
			for(index = 0; index < mWidgets.size(); index++) {
				widget = mWidgets.get(index);
				if(widget.getName() != null && 0 == widget.getName().compareTo(widgetName)) {
					return widget;
				}
			}
		}
		return null;
	}
	/*======================================================
	: ͨȡؼ
	:  
			index   [in] 
	
	ֵ: ӿؼ
	======================================================*/
	public HFBaseWidget getWidgetByIndex(int index) {
		synchronized(mWidgets)
		{
			if(index > -1 && index < mWidgets.size()) {
				return mWidgets.get(index);
			}
		}
		return null;
	}
	/*======================================================
	: ȡӿؼĸ
	:  
			index   [in] 
	
	ֵ: ӿؼĸ
	======================================================*/	
	public int getNumOfWidgets() {
		return mWidgets.size();
	}
	/*======================================================
	: ͨؼӿؼȡؼ
	˵: ButtonWidgetһButtonĳԱúͨbuttonԱButtonWidget
	:  
			widget   [in] Աؼ
	
	ֵ: ӿؼ
	======================================================*/
	protected HFBaseWidget findWidgetByObject(Object widget) {
		
		int index;
		HFBaseWidget base = null;
		for(index = 0; index < mWidgets.size(); index++) {
			base = mWidgets.get(index);
			if(widget == base.getObject()) {
				return base;
			}
		}
		return null;
	}
	/*======================================================
	: ؼλøı²
	: 
		  widget   [in] 
		  
	ֵ: 
	======================================================*/	
	protected void relayout(Object widget) {
		int widgetIndex = mWidgets.indexOf(widget);
		mWidgets.remove(widget);
		int childindex = indexOfChild(((HFBaseObject)widget).getObject());
		removeView(((HFBaseObject)widget).getObject());
		addWidget(widget,childindex,widgetIndex);
	}
	/*======================================================
	: ȡͼ
	:   
			
	ֵ:ͼ
	======================================================*/
	public String getName() {
		if(mLayerData != null && mLayerData.getName() != null)
		  return mLayerData.getName();
		return "";
	}
	/*======================================================
	: cloneһͼ
	˵ĿؼcloneʵǴļ´ЧŻĿռ
	:   
			
	ֵ:ͼ
	======================================================*/
	public HFLayerWidget clone() {
		HFLayerWidget layer = null;
		if(mContext != null) {
			HFModeWidget modeWidget = (HFModeWidget)mContext;
			HFModeLoader modeLoader = modeWidget.getModeLoader();
			if(modeLoader != null) {
				layer = modeWidget.createLayerWidgets(modeLoader, mLayerData);
				modeWidget.closeModeLoader(modeLoader);
			}
		}
		return layer;
	}
	public void inflate() {
		if(isReady())
			return ;
		
		if(mContext == null || mLayerData == null)
			return ;
		if(!mLayerData.isOptimized())
			return ;
		HFModeWidget modeWidget = (HFModeWidget)mContext;
		HFModeLoader modeLoader = modeWidget.getModeLoader();
		if(modeLoader != null) {
			loadWidgets(modeWidget, modeLoader);
			modeWidget.closeModeLoader(modeLoader);
		}
	}
	/*======================================================
	: ȡͼλ
	:   
			
	ֵ:ͼλ
	======================================================*/
	public HFWidgetBound getBound() {
		if(mLayerData != null && mLayerData.getBound() != null) {
			return mLayerData.getBound();
		}
		HFWidgetBound bound = new HFWidgetBound();
		LayoutParams layoutParam = (LayoutParams) getLayoutParams();
		if(layoutParam != null){
			bound.setLeft(layoutParam.x);
			bound.setTop(layoutParam.y);
			bound.setWidth(layoutParam.width);
			bound.setHeight(layoutParam.height);
		}
		
		return bound;
	}
	/*=======================================================
	: ÿؼλ
	:  widget     [in] ؼָ
	       in_pBound  [in] ؼλ

	ֵ: 
	======================================================*/
	public void setBound(HFWidgetBound bound) {
		if(mLayerData != null && bound != null) {
			mLayerData.setBound(bound);
			LayoutParams params = (LayoutParams) getLayoutParams();
			if(params == null) {
				params = new LayoutParams(	bound.getWidth(),
											bound.getHeight(),
											bound.getLeft(), 
											bound.getTop());
			} else {
				params.x = bound.getLeft();
				params.y = bound.getTop();
				params.width = bound.getWidth();
				params.height = bound.getHeight();
			}
			setLayoutParams(params);
		}
		return ;
	}
	/*======================================================
	: ȡؼId
	:   
			
	ֵ:ͼĸؼId
	======================================================*/	
	public int getParentId() {
		if(mLayerData != null) {
			return (int) mLayerData.getParent();
		}
		return 0;
	}
	
	/*======================================================
	: ȡؼId
	:   
			
	ֵ:ͼؼId
	======================================================*/	
	public int getWidgetId() {
		return mLayerId;
	}
	/*======================================================
	: ȡؼId
	:   
			
	ֵ:ͼؼId
	======================================================*/	
	public void setWidgetId(int id) {
		mLayerId = id;
	}	
	/*======================================================
	: ȡͼؼ
	:   
			
	ֵ:ͼؼ
	======================================================*/	
	public int getSubType() {
		if(mLayerData != null) {
			return mLayerData.getSubType();
		}
		return HFLayerSubType.eLayerSubType_Mode;
	}
	/*======================================================
	: ȡؼĿӱ־
	:  widget  [in] ؼָ
	ֵ: ӱ־
	======================================================*/
	public boolean getVisible() {
		return (getVisibility() == View.VISIBLE);
	}
	/*======================================================
	: ÿؼĿӱ־
	:  visible  [in] ӱ־
	ֵ: =0: ɹ; >0: 
	======================================================*/		
	public void setVisible(boolean visible) {
		setVisibility((visible) ? View.VISIBLE : View.INVISIBLE);
	}	
	
	@Override
	public void setVisibility(int visibility) {
		if(visibility == View.VISIBLE)
			inflate();	
		super.setVisibility(visibility);
	}
	/*======================================================
	: װdrawable
	:  
	ֵ: 
	======================================================*/
	protected void reloadDrawable() {
		int index;
		HFBaseWidget base = null;
		HFDrawableWidget drawable = null;
		for(index = 0; index < mWidgets.size(); index++) {
			base = mWidgets.get(index);
			if(base != null) {
				drawable = base.getDefaultDrawable();
				if(drawable != null && drawable.getBitmap() != null) {
					base.setDefaultDrawable(drawable);
				}
			}
		}
	}
	/*======================================================
	: ʵͼڵĿؼл
	: 	mode       	[in] ͼڵģʽ
			modeLoader	[in] ģʽװ
			pLayerData  [in] ͼ
	
	ֵ: =0: лɹ; >0: 
	======================================================*/
	protected int changeOrientation(HFModeWidget mode, 
									HFModeLoader modeLoader,
									HFLayerStorage pLayerData,
									ArrayList<HFLayerWidget> listLayers) {
		
		mLayerData = (HFLayerStorage)pLayerData;
		if(mLayerData == null && modeLoader == null) {
			return HFErrorCode.HF_ERROR_WIDGET_MEMBERS_INVALID;
		}	
		setBound(mLayerData.getBound());
		int numWidgets = mLayerData.getNumOfWidgets();
		int layerId = mLayerData.getId();
		HFBaseWidget pFind = null;
		//λؼָ
		modeLoader.reset();
		for(int index = 0; index < numWidgets; index++) {
			HFBaseStorage widgetData = modeLoader.getNextWidgetData(layerId);
			if(widgetData != null) {
				int fixedshape = widgetData.getFixedShapeEnabled();
				//
				mode.scaleCoords(widgetData.getBound(),fixedshape);
				
				if(widgetData instanceof HFTextItemStorage){
					HFTextItemStorage mTextItem = (HFTextItemStorage)widgetData;
					float xScale = mode.getXScaleFactor();
					float yScale = mode.getYScaleFactor();
					float minScale = Math.min(xScale, yScale);
					if(HFModesManager.isScaleMode()) {
					mTextItem.getMargin().setLeft((short)Math.ceil(mTextItem.getMargin().getLeft()* xScale));
					mTextItem.getMargin().setRight((short)Math.ceil(mTextItem.getMargin().getRight() * xScale));
					mTextItem.getMargin().setTop((short)Math.ceil(mTextItem.getMargin().getTop() * yScale));
					mTextItem.getMargin().setBottom((short)Math.ceil(mTextItem.getMargin().getBottom() * yScale));
					//С
					mTextItem.getFont().setSize((float)Math.ceil(minScale * mTextItem.getFont().getSize()));
					}
				}
				if(widgetData instanceof HFSwitchStorage){
					HFSwitchStorage mSwitchStorage = (HFSwitchStorage)widgetData;
					mode.scaleCoords(mSwitchStorage.getSwitchBound(),fixedshape);
				}
				if(widgetData instanceof HFExpandableListStorage){
					HFExpandableListStorage mListStorage = (HFExpandableListStorage)widgetData;
					for(int i = 0; i < mListStorage.getNumOfListItems();i++)
						//ģʽͼListViewеListItem
						mode.scaleCoords(mListStorage.getItem(i).getBound(),fixedshape);
				}
				if(widgetData instanceof HFSliderStorage){
					float xScale = mode.getXScaleFactor();
					float yScale = mode.getYScaleFactor();
					HFSliderStorage mSliderStorage = (HFSliderStorage)widgetData;
					mode.scaleCoords(mSliderStorage.getButton().getBound(),fixedshape);
					if(mSliderStorage.getUpOrder() >=0)
					  mSliderStorage.setUpOrder((int)(mSliderStorage.getUpOrder() * yScale));
					if(mSliderStorage.getDownOrder() >= 0)
					  mSliderStorage.setDownOrder((int)(mSliderStorage.getDownOrder() * yScale));
					if(mSliderStorage.getLeftOrder() >=0)
					  mSliderStorage.setLeftOrder((int)(mSliderStorage.getLeftOrder() * xScale));
					if(mSliderStorage.getRightOrder() >= 0)
					  mSliderStorage.setRightOrder((int)(mSliderStorage.getRightOrder() * xScale));
					
				}
				pFind = (HFBaseWidget)findWidgetByName(widgetData.getName());
				if(pFind != null) {
					HFModeWidget modeWidget = HFModesManager.getCurrentMode();
					//DģʽͼΪactivityл˳ʱonDestroyִmodeIdô󣬵µʧЧ
					pFind.setModeId(modeWidget.getModeId());
					//бؼҪ⴦
					if(pFind.getType() == HFWidgetType.eWidgetType_List) {
						HFExpandableListWidget listWidget = (HFExpandableListWidget) pFind;
						listWidget.changeOrientation(widgetData, listLayers);
					}
					else {
						pFind.changeOrientation(widgetData);
					}
					relayout(pFind);
				}
			}
		}
		return HFErrorCode.HF_SUCCESS;
	}
	/*======================================================
	: ʵͼڵĿؼл
	: 	layer   [in] ͼ

	
	ֵ: =0: лɹ; >0: 
	======================================================*/
	protected int changeOrientation(HFLayerWidget layer) {
		
		if(layer == null && mWidgets == null) {
			return HFErrorCode.HF_ERROR_WIDGET_MEMBERS_INVALID;
		}
		int numWidgets = mWidgets.size();
		HFBaseWidget	pFind = null, 
						pWidget = null;
		
		for(int index = 0; index < numWidgets; index++) {
			pWidget = mWidgets.get(index);
			pFind = (HFBaseWidget)layer.findWidgetByName(pWidget.getName());
			if(pFind != null && pWidget.getType() == pFind.getType()) {
				pWidget.changeOrientation(pFind);
				//pWidget.setLayout(this);
				relayout(pWidget);
			}
		}
		return HFErrorCode.HF_SUCCESS;
	}	
	/*======================================================
	: ӿؼswithWidgetchecked
	: 
	ֵ: 
	======================================================*/
/*	
	private void setSwitchWidgetChecked() {
		int index;
		HFBaseWidget widget = null;
		for(index = 0; index < mWidgets.size(); index++) {
			widget = mWidgets.get(index);
			if(widget instanceof HFSwitchWidget) {
				boolean bChecked = ((HFSwitchWidget)widget).getChecked();
				bChecked = (!bChecked || (widget instanceof HFCheckBoxWidget)) ? (!bChecked):(bChecked);
				((HFSwitchWidget)widget).setChecked(bChecked);
			}
		}
	}
	
	//ȡǰviewĸ
	private View getListView(View v) {
		
		ViewParent temp = v.getParent();
		ViewParent parent = v.getParent();
		
		while(parent != null) {
			
			if(parent.getClass().equals(ListView.class)) {
				return (View) temp;
			}
			temp = parent;
			parent = parent.getParent();
		}
		return null;
	}
*/	
	/*======================================================
	: ִбĵ¼
	: 
	ֵ: false δִУtrue ִ
	======================================================*/
	/*
	private boolean performItemClick() {
		
		View parent = getListView(this); 
		if(parent != null && mContext != null) {
			 //setSwitchWidgetChecked();
			HFModeWidget modeWidget = (HFModeWidget)mContext;
			HFListWidget listWidget = (HFListWidget) modeWidget.findWidgetByObject(parent);
			 if(listWidget != null) {
				 return listWidget.performItemClick(this);
			 }
		}
		return false;
	}
	 */
	/*======================================================
	: layoutonInterceptTouchEventػ¼
	: ev [in] ¼  
			
	ֵ:falseʾ¼δػ񣬻ɷ
	                 trueʾ¼ػ񣬲ɷ
	                 Զfalse.
	======================================================*/	
	/*	
    @Override
    public boolean onInterceptTouchEvent(MotionEvent ev) {

        int action = ev.getAction();

        switch(action){

        case MotionEvent.ACTION_UP:
        	performItemClick();
             break;
        }
        return false;
    }
*/    
	
	protected long getTagEx() {
		return mTagEx;
	}

	protected void setTagEx(long mTagEx) {
		this.mTagEx = mTagEx;
	}
	/*======================================================
	: ȡͼ㴴бؼĸ
	:  
	ֵ: бؼĸ
	======================================================*/
	protected int getListWidgetCount() {
		return mListWidgetCount;
	}
	/*======================================================
	: жǷбؼ
	:  
	ֵ: true: бؼfalse: бؼ
	======================================================*/	
	protected boolean isHaveListWidget() {
		return (getListWidgetCount() > 0);
	}
	//BaseObjectSubType
	public	class HFLayerSubType	{
	    //ģʽͼ
	    public final static int eLayerSubType_Mode   =  0x00000001;  
	    //ӿؼͼ(бϵͼ㡢TabBarϵͼ㶼ӿؼ)
	    public final static int eLayerSubType_Child   = 0x00000002;   
	} ;
	
	/*======================================================
	:  ƽƶ
	:  fromXValue  [in] Xʼ
	       toXValue    [in] X
	       fromYValue  [in] Yʼ
	       toYValue    [in] Y
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startTranslateAnimation(float fromXValue, float toXValue, float fromYValue, float toYValue,long durationMillis,Interpolator interpolator,AnimationListener listener){
		TranslateAnimation mAnimation = HFAnimationFactory.getTranslateAnimation(fromXValue, toXValue, fromYValue, toYValue, durationMillis,interpolator,listener);
		startAnimation(mAnimation);
	}
	
	/*======================================================
	: Ŷ
	:  fromX      [in]  [0,1]Xűʼֵ
	       toX        [in]  [0,1]Xűֵ
	       fromY      [in]  [0,1]Yűʼֵ
	       toY        [in]  [0,1]Yűֵ
	       pivotX     [in]  ĵX[0ؼwidth]
	       pivotY     [in]  ĵY[0ؼ߶height]
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startScaleAnimation(float fromX, float toX, float fromY, float toY, float pivotX, float pivotY,long durationMillis,Interpolator interpolator,AnimationListener listener){
		ScaleAnimation mAnimation = HFAnimationFactory.getScaleAnimation(fromX, toX, fromY, toY, pivotX, pivotY, durationMillis,interpolator,listener);
		startAnimation(mAnimation);
	}
	
	/*======================================================
	:  ͸ȶ
	:  fromAlpha   [in]  ʼAlphaֵ
	       toAlpha     [in]  Alphaֵ
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startAlphaAnimation(float fromAlpha, float toAlpha,long durationMillis,Interpolator interpolator,AnimationListener listener){
		AlphaAnimation mAnimation = HFAnimationFactory.getAlphaAnimation(fromAlpha, toAlpha, durationMillis,interpolator,listener);
		startAnimation(mAnimation);
	}
	
	/*======================================================
	: ת̬
	:  fromDegrees   [in]  ʼǶ[0,360]
	       toDegrees     [in]  Ƕ[0,360]
	       pivotXValue   [in]  תĵX[0ؼwidth]
	       pivotYValue   [in]  ĵY[0ؼ߶height]
	       durationMillis    [in]ʱ
	ֵ:
	======================================================*/
	public void startRotateAnimation(float fromDegrees, float toDegrees, float pivotXValue, float pivotYValue,long durationMillis,Interpolator interpolator,AnimationListener listener){
		RotateAnimation mAnimation = HFAnimationFactory.getRotateAnimation(fromDegrees, toDegrees, pivotXValue, pivotYValue, durationMillis,interpolator,listener);
		startAnimation(mAnimation);
	}

	public boolean isReady() {
		return mIsReady;
	}

	public void setIsReady(boolean mIsReady) {
		this.mIsReady = mIsReady;
	}
	
	/**
	 * @see android.view.View#draw(android.graphics.Canvas)
	 */
	@Override
	public void draw(Canvas canvas) {
		// TODO Auto-generated method stub
		if(mDraw != null)
			mDraw.draw(canvas,this);
		else
			super.draw(canvas);
	}
	
	
	/** superDrawл
	 * @param canvas
	 * @return void
	 * @author LiangYJ
	 * @date 2015-8-20 11:46:11
	 */ 
	public void superDraw(Canvas canvas){
		if(canvas != null)
			super.draw(canvas);
	}
	
	public interface ILayerDrawListener {
		public void draw(Canvas canvas,AbsoluteLayout layout);
	}
	
	/** drawӿڣϲִлȻsuperDrawл
	 * @param draw
	 * @return void
	 * @author LiangYJ
	 * @date 2015-8-20 11:45:10
	 */ 
	public void setLayerDrawListener(ILayerDrawListener draw){
		mDraw = draw;
	}
	public byte getB2VeiledEffect() {
		return b2VeiledEffect;
	}

	public void setB2VeiledEffect(byte b2VeiledEffect) {
		this.b2VeiledEffect = b2VeiledEffect;
	}
	
//	/**
//	 * @see android.widget.AbsoluteLayout#onLayout(boolean, int, int, int, int)
//	 */
//	@Override
//	protected void onLayout(boolean changed, int l, int t, int r, int b) {
//		// TODO Auto-generated method stub
//		super.onLayout(changed, l, t, r, b);
//		if (checkLayoutSizeChange) {
//			// if (changed) {
//			Toast.makeText(getContext(), "ֱ仯---b:" + b, Toast.LENGTH_SHORT)
//					.show();
//			// }
//		}
//	}
}
