package cnv.hf.widgets;

import cnv.hf.widgets.HFWidgetStorage.HFBaseStorage;
import cnv.hf.widgets.HFWidgetsManager.HFWidgetType;
import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.widget.AbsoluteLayout.LayoutParams;

public class HFMapFragment extends Fragment {
	//ͼؼ
	private final static String HF_MAPVIEW_NAME = "MapView";
	//ͼؼ
	private HFMapWidget mMapWidget = null;
	private HFLayerWidget mLayerMap = null;
	private static HFMapFragment mMapFragment = null;
	
	public static HFMapFragment getInstance() {
		if(mMapFragment == null) {
			mMapFragment = new HFMapFragment();
		}
		return mMapFragment;
	}
	protected void init(Context context) {
		
		HFMapActivity mode = (HFMapActivity) context;
		//ȡǰĻĿ
		int width = mode.getWindowManager().getDefaultDisplay().getWidth();
		int height = mode.getWindowManager().getDefaultDisplay().getHeight();
		//һͼؼݶ
		HFBaseStorage data = new HFBaseStorage();
		//ÿؼ
		data.setName(HF_MAPVIEW_NAME);
		//ÿؼλ
		data.setBound(0, 0, width, height);
		//ÿؼ
		data.setType((short)HFWidgetType.eWidgetType_MapView);
		//ͼؼ
		mMapWidget = new HFMapWidget(context, data);
		//һͼΪװͼؼ
		mLayerMap = new HFLayerWidget(context,true);
		//ͼĴС
		mLayerMap.setBound(new HFWidgetBound(0, 0, width, LayoutParams.MATCH_PARENT));
		//װͼؼ
		mLayerMap.addWidget(mMapWidget,-1,-1);
	}
	public HFMapWidget getMapWidget() {
		return mMapWidget;
	}
	public HFLayerWidget getMapLayer() {
		if(mLayerMap != null) {
			removeParent();
		}
		return mLayerMap;
	}
	protected void removeParent() {
		ViewParent parent = mLayerMap.getParent();
		if(parent != null && parent instanceof ViewGroup) {
			ViewGroup vg = (ViewGroup) parent;
			vg.removeView(mLayerMap);
		}
	}
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
   
    	if(mLayerMap == null) {
    		init(getActivity());
    	}
    	else {
    		removeParent();
    	}
        return mLayerMap;
    }
	//activityonResume
	@Override
	public void onResume() {
		if(mMapWidget != null) {
			mMapWidget.onResume();
		}
		super.onResume();	
	}
	//activityonPause
	@Override
	public void onPause() {
		if(mMapWidget != null) {
			mMapWidget.onPause();
		}		
		super.onPause();	
	}	
	public String getName() {
		return HF_MAPVIEW_NAME;
	}
}
