package cnv.hf.widgets;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.util.Log;

public class HFProgressMessage {
	
    private static HFProgressDialog progressDialog = null;
    private static Object synObj = new Object();  
 
    public static boolean isShowingProgress(){
    	if(progressDialog != null)
    	  return progressDialog.isShowing();
    	return false;
    }
    public static void showProgress(final Context context,  final String title, final String msg) {  
     	Activity act = (Activity) context;
    	act.runOnUiThread(new Runnable() {
			@Override
			public void run() {
                synchronized (synObj) {  
                    if (progressDialog != null) {  
                    	progressDialog.dismiss();  
                    }  
                	progressDialog = new HFProgressDialog(context);
                	progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
                	progressDialog.setIndeterminate(true);
                	progressDialog.setCancelable(false);
                	if(title != null && title.length() > 0) {
                		progressDialog.setTitle(title);
                	}
                	progressDialog.setMessage(msg);                            
                    progressDialog.show();
                }  
			}
    	});       
    }
    
    public static void cancelProgress(final Context context){
    	closeProgress(context);
    }
    
    public static void closeProgress(final Context context) {  
     	Activity act = (Activity) context;
    	act.runOnUiThread(new Runnable() {
			@Override
			public void run() {		
                synchronized (synObj) {  
                    if (progressDialog != null) {  
                    	progressDialog.dismiss();
                    }
                    progressDialog = null;
                }  				
			}
    	});    		
    }  
}
